
/* File: _polkitauthority.h
 *
 * Generated by eggdbus-binding-tool 0.6. Do not edit.
 */

#ifndef ___POLKIT_AUTHORITY_H
#define ___POLKIT_AUTHORITY_H

#include <glib-object.h>
#include <gio/gio.h>
#include "_polkitbindingstypes.h"

G_BEGIN_DECLS

#define _POLKIT_TYPE_AUTHORITY         (_polkit_authority_get_type())
#define _POLKIT_AUTHORITY(o)           (G_TYPE_CHECK_INSTANCE_CAST ((o), _POLKIT_TYPE_AUTHORITY, _PolkitAuthority))
#define _POLKIT_IS_AUTHORITY(o)        (G_TYPE_CHECK_INSTANCE_TYPE ((o), _POLKIT_TYPE_AUTHORITY))
#define _POLKIT_AUTHORITY_GET_IFACE(o) (G_TYPE_INSTANCE_GET_INTERFACE((o), _POLKIT_TYPE_AUTHORITY, _PolkitAuthorityIface))

#if 0
typedef struct __PolkitAuthority _PolkitAuthority; /* Dummy typedef */
#endif
typedef struct __PolkitAuthorityIface _PolkitAuthorityIface;

/**
 * _POLKIT_QUERY_INTERFACE_AUTHORITY:
 * @object_proxy: A #EggDBusObjectProxy.
 *
 * Convenience macro to get an interface proxy for the remote object represented
 * by @object_proxy. See egg_dbus_object_proxy_query_interface() for details.
 *
 * Returns: An instance derived from #EggDBusInterfaceProxy that implements the
 *          #_PolkitAuthority interface. This instance can be used to access the
 *          <link linkend="eggdbus-interface-org.freedesktop.PolicyKit1.Authority">org.freedesktop.PolicyKit1.Authority</link> D-Bus interface on the remote
 *          object represented by @object_proxy. Do not ref or unref the returned instance,
 *          it is owned by @object_proxy.
 */
#define _POLKIT_QUERY_INTERFACE_AUTHORITY(object_proxy) (_POLKIT_AUTHORITY (egg_dbus_object_proxy_query_interface (object_proxy, _POLKIT_TYPE_AUTHORITY)))

/**
 * _PolkitAuthorityIface:
 * @g_iface: The parent interface.
 * @handle_enumerate_actions: Enumerates all registered PolicyKit actions.
 * @handle_check_authorization: <para>Checks if @subject is authorized to perform the action with identifier @action_id.</para><para>If @cancellation_id is non-empty and already in use for the caller, the %_POLKIT_ERROR_CANCELLATION_ID_NOT_UNIQUE error is returned.</para><para>Note that %_POLKIT_CHECK_AUTHORIZATION_FLAGS_ALLOW_USER_INTERACTION SHOULD be passed ONLY if the event that triggered the authorization check is stemming from an user action, e.g. the user pressing a button or attaching a device.</para>
 * @handle_cancel_check_authorization: Cancels an authorization check.
 * @handle_register_authentication_agent: <para>Register an authentication agent.</para><para>Note that current versions of PolicyKit will only work if @session_id is set to the empty string. In the future it might work for non-empty strings if the caller is sufficiently privileged.</para>
 * @handle_unregister_authentication_agent: Unregister an authentication agent.
 * @handle_authentication_agent_response: Method for authentication agents to invoke on successful authentication. This method will fail unless a sufficiently privileged caller invokes it.
 * @handle_enumerate_temporary_authorizations: Retrieves all temporary authorizations that applies to @subject.
 * @handle_revoke_temporary_authorizations: Revokes all temporary authorizations that applies to @subject.
 * @handle_revoke_temporary_authorization_by_id: Revokes all temporary authorizations that applies to @subject.
 * @handle_add_lockdown_for_action: Locks down an action so administrator authentication is always needed to obtain a temporary authorization for the action.
 * @handle_remove_lockdown_for_action: Removes the effect of a previous _polkit_authority_add_lockdown_for_action() call.
 *
 * Interface VTable for implementing the <link linkend="eggdbus-interface-org.freedesktop.PolicyKit1.Authority">org.freedesktop.PolicyKit1.Authority</link> D-Bus interface.
 */
struct __PolkitAuthorityIface
{
  EggDBusInterfaceIface g_iface;

  void (* handle_enumerate_actions) (
      _PolkitAuthority *instance,
      const gchar *locale,
      EggDBusMethodInvocation *method_invocation);

  void (* handle_check_authorization) (
      _PolkitAuthority *instance,
      _PolkitSubject *subject,
      const gchar *action_id,
      EggDBusHashMap *details,
      _PolkitCheckAuthorizationFlags flags,
      const gchar *cancellation_id,
      EggDBusMethodInvocation *method_invocation);

  void (* handle_cancel_check_authorization) (
      _PolkitAuthority *instance,
      const gchar *cancellation_id,
      EggDBusMethodInvocation *method_invocation);

  void (* handle_register_authentication_agent) (
      _PolkitAuthority *instance,
      _PolkitSubject *subject,
      const gchar *locale,
      const gchar *object_path,
      EggDBusMethodInvocation *method_invocation);

  void (* handle_unregister_authentication_agent) (
      _PolkitAuthority *instance,
      _PolkitSubject *subject,
      const gchar *object_path,
      EggDBusMethodInvocation *method_invocation);

  void (* handle_authentication_agent_response) (
      _PolkitAuthority *instance,
      const gchar *cookie,
      _PolkitIdentity *identity,
      EggDBusMethodInvocation *method_invocation);

  void (* handle_enumerate_temporary_authorizations) (
      _PolkitAuthority *instance,
      _PolkitSubject *subject,
      EggDBusMethodInvocation *method_invocation);

  void (* handle_revoke_temporary_authorizations) (
      _PolkitAuthority *instance,
      _PolkitSubject *subject,
      EggDBusMethodInvocation *method_invocation);

  void (* handle_revoke_temporary_authorization_by_id) (
      _PolkitAuthority *instance,
      const gchar *id,
      EggDBusMethodInvocation *method_invocation);

  void (* handle_add_lockdown_for_action) (
      _PolkitAuthority *instance,
      const gchar *action_id,
      EggDBusMethodInvocation *method_invocation);

  void (* handle_remove_lockdown_for_action) (
      _PolkitAuthority *instance,
      const gchar *action_id,
      EggDBusMethodInvocation *method_invocation);
};

GType _polkit_authority_get_type (void) G_GNUC_CONST;

guint _polkit_authority_override_properties (GObjectClass *klass, guint property_id_begin) G_GNUC_WARN_UNUSED_RESULT;

gchar *_polkit_authority_get_backend_name (_PolkitAuthority *instance);


gchar *_polkit_authority_get_backend_version (_PolkitAuthority *instance);


_PolkitAuthorityFeatures _polkit_authority_get_backend_features (_PolkitAuthority *instance);


gboolean _polkit_authority_enumerate_actions_sync (
    _PolkitAuthority *instance,
    EggDBusCallFlags call_flags,
    const gchar *locale,
    EggDBusArraySeq **out_action_descriptions,
    GCancellable *cancellable,
    GError **error);

gboolean _polkit_authority_check_authorization_sync (
    _PolkitAuthority *instance,
    EggDBusCallFlags call_flags,
    _PolkitSubject *subject,
    const gchar *action_id,
    EggDBusHashMap *details,
    _PolkitCheckAuthorizationFlags flags,
    const gchar *cancellation_id,
    _PolkitAuthorizationResult **out_result,
    GCancellable *cancellable,
    GError **error);

gboolean _polkit_authority_cancel_check_authorization_sync (
    _PolkitAuthority *instance,
    EggDBusCallFlags call_flags,
    const gchar *cancellation_id,
    GCancellable *cancellable,
    GError **error);

gboolean _polkit_authority_register_authentication_agent_sync (
    _PolkitAuthority *instance,
    EggDBusCallFlags call_flags,
    _PolkitSubject *subject,
    const gchar *locale,
    const gchar *object_path,
    GCancellable *cancellable,
    GError **error);

gboolean _polkit_authority_unregister_authentication_agent_sync (
    _PolkitAuthority *instance,
    EggDBusCallFlags call_flags,
    _PolkitSubject *subject,
    const gchar *object_path,
    GCancellable *cancellable,
    GError **error);

gboolean _polkit_authority_authentication_agent_response_sync (
    _PolkitAuthority *instance,
    EggDBusCallFlags call_flags,
    const gchar *cookie,
    _PolkitIdentity *identity,
    GCancellable *cancellable,
    GError **error);

gboolean _polkit_authority_enumerate_temporary_authorizations_sync (
    _PolkitAuthority *instance,
    EggDBusCallFlags call_flags,
    _PolkitSubject *subject,
    EggDBusArraySeq **out_temporary_authorizations,
    GCancellable *cancellable,
    GError **error);

gboolean _polkit_authority_revoke_temporary_authorizations_sync (
    _PolkitAuthority *instance,
    EggDBusCallFlags call_flags,
    _PolkitSubject *subject,
    GCancellable *cancellable,
    GError **error);

gboolean _polkit_authority_revoke_temporary_authorization_by_id_sync (
    _PolkitAuthority *instance,
    EggDBusCallFlags call_flags,
    const gchar *id,
    GCancellable *cancellable,
    GError **error);

gboolean _polkit_authority_add_lockdown_for_action_sync (
    _PolkitAuthority *instance,
    EggDBusCallFlags call_flags,
    const gchar *action_id,
    GCancellable *cancellable,
    GError **error);

gboolean _polkit_authority_remove_lockdown_for_action_sync (
    _PolkitAuthority *instance,
    EggDBusCallFlags call_flags,
    const gchar *action_id,
    GCancellable *cancellable,
    GError **error);

guint _polkit_authority_enumerate_actions (
    _PolkitAuthority *instance,
    EggDBusCallFlags call_flags,
    const gchar *locale,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean _polkit_authority_enumerate_actions_finish (
    _PolkitAuthority *instance,
    EggDBusArraySeq **out_action_descriptions,
    GAsyncResult *res,
    GError **error);

guint _polkit_authority_check_authorization (
    _PolkitAuthority *instance,
    EggDBusCallFlags call_flags,
    _PolkitSubject *subject,
    const gchar *action_id,
    EggDBusHashMap *details,
    _PolkitCheckAuthorizationFlags flags,
    const gchar *cancellation_id,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean _polkit_authority_check_authorization_finish (
    _PolkitAuthority *instance,
    _PolkitAuthorizationResult **out_result,
    GAsyncResult *res,
    GError **error);

guint _polkit_authority_cancel_check_authorization (
    _PolkitAuthority *instance,
    EggDBusCallFlags call_flags,
    const gchar *cancellation_id,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean _polkit_authority_cancel_check_authorization_finish (
    _PolkitAuthority *instance,
    GAsyncResult *res,
    GError **error);

guint _polkit_authority_register_authentication_agent (
    _PolkitAuthority *instance,
    EggDBusCallFlags call_flags,
    _PolkitSubject *subject,
    const gchar *locale,
    const gchar *object_path,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean _polkit_authority_register_authentication_agent_finish (
    _PolkitAuthority *instance,
    GAsyncResult *res,
    GError **error);

guint _polkit_authority_unregister_authentication_agent (
    _PolkitAuthority *instance,
    EggDBusCallFlags call_flags,
    _PolkitSubject *subject,
    const gchar *object_path,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean _polkit_authority_unregister_authentication_agent_finish (
    _PolkitAuthority *instance,
    GAsyncResult *res,
    GError **error);

guint _polkit_authority_authentication_agent_response (
    _PolkitAuthority *instance,
    EggDBusCallFlags call_flags,
    const gchar *cookie,
    _PolkitIdentity *identity,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean _polkit_authority_authentication_agent_response_finish (
    _PolkitAuthority *instance,
    GAsyncResult *res,
    GError **error);

guint _polkit_authority_enumerate_temporary_authorizations (
    _PolkitAuthority *instance,
    EggDBusCallFlags call_flags,
    _PolkitSubject *subject,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean _polkit_authority_enumerate_temporary_authorizations_finish (
    _PolkitAuthority *instance,
    EggDBusArraySeq **out_temporary_authorizations,
    GAsyncResult *res,
    GError **error);

guint _polkit_authority_revoke_temporary_authorizations (
    _PolkitAuthority *instance,
    EggDBusCallFlags call_flags,
    _PolkitSubject *subject,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean _polkit_authority_revoke_temporary_authorizations_finish (
    _PolkitAuthority *instance,
    GAsyncResult *res,
    GError **error);

guint _polkit_authority_revoke_temporary_authorization_by_id (
    _PolkitAuthority *instance,
    EggDBusCallFlags call_flags,
    const gchar *id,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean _polkit_authority_revoke_temporary_authorization_by_id_finish (
    _PolkitAuthority *instance,
    GAsyncResult *res,
    GError **error);

guint _polkit_authority_add_lockdown_for_action (
    _PolkitAuthority *instance,
    EggDBusCallFlags call_flags,
    const gchar *action_id,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean _polkit_authority_add_lockdown_for_action_finish (
    _PolkitAuthority *instance,
    GAsyncResult *res,
    GError **error);

guint _polkit_authority_remove_lockdown_for_action (
    _PolkitAuthority *instance,
    EggDBusCallFlags call_flags,
    const gchar *action_id,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean _polkit_authority_remove_lockdown_for_action_finish (
    _PolkitAuthority *instance,
    GAsyncResult *res,
    GError **error);

void _polkit_authority_handle_enumerate_actions_finish (
    EggDBusMethodInvocation *method_invocation,
    EggDBusArraySeq *out_action_descriptions);

void _polkit_authority_handle_check_authorization_finish (
    EggDBusMethodInvocation *method_invocation,
    _PolkitAuthorizationResult *out_result);

void _polkit_authority_handle_cancel_check_authorization_finish (
    EggDBusMethodInvocation *method_invocation);

void _polkit_authority_handle_register_authentication_agent_finish (
    EggDBusMethodInvocation *method_invocation);

void _polkit_authority_handle_unregister_authentication_agent_finish (
    EggDBusMethodInvocation *method_invocation);

void _polkit_authority_handle_authentication_agent_response_finish (
    EggDBusMethodInvocation *method_invocation);

void _polkit_authority_handle_enumerate_temporary_authorizations_finish (
    EggDBusMethodInvocation *method_invocation,
    EggDBusArraySeq *out_temporary_authorizations);

void _polkit_authority_handle_revoke_temporary_authorizations_finish (
    EggDBusMethodInvocation *method_invocation);

void _polkit_authority_handle_revoke_temporary_authorization_by_id_finish (
    EggDBusMethodInvocation *method_invocation);

void _polkit_authority_handle_add_lockdown_for_action_finish (
    EggDBusMethodInvocation *method_invocation);

void _polkit_authority_handle_remove_lockdown_for_action_finish (
    EggDBusMethodInvocation *method_invocation);

void _polkit_authority_emit_signal_changed (
    _PolkitAuthority *instance,
    const gchar *destination);

G_END_DECLS

#endif /* ___POLKIT_AUTHORITY_H */
