
/* File: _polkitidentity.c
 *
 * Generated by eggdbus-binding-tool 0.6. Do not edit.
 */

#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif
#include <string.h>
#include "_polkitbindingstypes.h"
#include "_polkitbindings.h"
#include "_polkitidentity.h"

/**
 * SECTION:_polkitidentity
 * @title: _PolkitIdentity
 * @short_description: Identities
 *
 * <para>This struct describes identities such as UNIX users and UNIX groups. It is typically used to check if a given process is authorized for an action.</para><para>The following kinds of identities are known:</para>                   <formalpara><title>Unix User</title><para><literal>identity_kind</literal> should be set to <literal>unix-user</literal> with key <literal>uid</literal> (of type <literal>uint32</literal>).</para></formalpara>                   <formalpara><title>Unix Group</title><para><literal>identity_kind</literal> should be set to <literal>unix-group</literal> with key <literal>gid</literal> (of type <literal>uint32</literal>).</para></formalpara>  
 */

G_DEFINE_TYPE (_PolkitIdentity, _polkit_identity, EGG_DBUS_TYPE_STRUCTURE);

static void
_polkit_identity_init (_PolkitIdentity *instance)
{
}

static void
_polkit_identity_class_init (_PolkitIdentityClass *klass)
{
}

/**
 * _polkit_identity_get_identity_kind:
 * @instance: A #_PolkitIdentity.
 *
 * Gets element 0 of the #EggDBusStructure wrapped by #_PolkitIdentity.
 *
 * Returns: Type of identity.
 */
const gchar *
_polkit_identity_get_identity_kind (_PolkitIdentity *instance)
{
  const gchar *value;

  g_return_val_if_fail (_POLKIT_IS_IDENTITY (instance), NULL);

  egg_dbus_structure_get_element (EGG_DBUS_STRUCTURE (instance),
                0, &value,
                -1);

  return value;
}

/**
 * _polkit_identity_get_identity_details:
 * @instance: A #_PolkitIdentity.
 *
 * Gets element 1 of the #EggDBusStructure wrapped by #_PolkitIdentity.
 *
 * Returns: Details about the identity. Depending of the value of @identity_kind, a set of well-defined key/value pairs are guaranteed to be available.
 */
EggDBusHashMap *
_polkit_identity_get_identity_details (_PolkitIdentity *instance)
{
  EggDBusHashMap *value;

  g_return_val_if_fail (_POLKIT_IS_IDENTITY (instance), NULL);

  egg_dbus_structure_get_element (EGG_DBUS_STRUCTURE (instance),
                1, &value,
                -1);

  return value;
}


/**
 * _polkit_identity_set_identity_kind:
 * @instance: A #_PolkitIdentity.
 * @value: Type of identity.
 *
 * Sets element 0 of the #EggDBusStructure wrapped by #_PolkitIdentity.
 */
void
_polkit_identity_set_identity_kind (_PolkitIdentity *instance, const gchar *value)
{
  g_return_if_fail (_POLKIT_IS_IDENTITY (instance));

  egg_dbus_structure_set_element (EGG_DBUS_STRUCTURE (instance),
                0, value,
                -1);
}

/**
 * _polkit_identity_set_identity_details:
 * @instance: A #_PolkitIdentity.
 * @value: Details about the identity. Depending of the value of @identity_kind, a set of well-defined key/value pairs are guaranteed to be available.
 *
 * Sets element 1 of the #EggDBusStructure wrapped by #_PolkitIdentity.
 */
void
_polkit_identity_set_identity_details (_PolkitIdentity *instance, EggDBusHashMap *value)
{
  g_return_if_fail (_POLKIT_IS_IDENTITY (instance));

  egg_dbus_structure_set_element (EGG_DBUS_STRUCTURE (instance),
                1, value,
                -1);
}


/**
 * _polkit_identity_new:
 * @identity_kind: Type of identity.
 * @identity_details: Details about the identity. Depending of the value of @identity_kind, a set of well-defined key/value pairs are guaranteed to be available.
 *
 * Constructs a new #_PolkitIdentity.
 *
 * Returns: A #_PolkitIdentity.
 */
_PolkitIdentity *
_polkit_identity_new (const gchar *identity_kind, EggDBusHashMap *identity_details)
{
  GValue *values;
  _PolkitIdentity *structure;

  values = g_new0 (GValue, 2);

  g_value_init (&(values[0]), G_TYPE_STRING);
  g_value_set_string (&(values[0]), identity_kind);

  g_value_init (&(values[1]), EGG_DBUS_TYPE_HASH_MAP);
  g_value_set_object (&(values[1]), identity_details);

  structure = _POLKIT_IDENTITY (g_object_new (_POLKIT_TYPE_IDENTITY, "signature", "(sa{sv})", "elements", values, NULL));

  return structure;
}

