
/* File: _polkitsubject.c
 *
 * Generated by eggdbus-binding-tool 0.6. Do not edit.
 */

#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif
#include <string.h>
#include "_polkitbindingstypes.h"
#include "_polkitbindings.h"
#include "_polkitsubject.h"

/**
 * SECTION:_polkitsubject
 * @title: _PolkitSubject
 * @short_description: Subjects
 *
 * <para>This struct describes subjects such as UNIX processes. It is typically used to check if a given process is authorized for an action.</para><para>The following kinds of subjects are known:</para>                   <formalpara><title>Unix Process</title><para><literal>subject_kind</literal> should be set to <literal>unix-process</literal> with keys <literal>pid</literal> (of type <literal>uint32</literal>) and <literal>start-time</literal> (of type <literal>uint64</literal>).</para></formalpara>                   <formalpara><title>Unix Session</title><para><literal>subject_kind</literal> should be set to <literal>unix-session</literal> with the key <literal>session-id</literal> (of type <literal>string</literal>).</para></formalpara>                   <formalpara><title>System Bus Name</title><para><literal>subject_kind</literal> should be set to <literal>system-bus-name</literal> with the key <literal>name</literal> (of type <literal>string</literal>).</para></formalpara>
 */

G_DEFINE_TYPE (_PolkitSubject, _polkit_subject, EGG_DBUS_TYPE_STRUCTURE);

static void
_polkit_subject_init (_PolkitSubject *instance)
{
}

static void
_polkit_subject_class_init (_PolkitSubjectClass *klass)
{
}

/**
 * _polkit_subject_get_subject_kind:
 * @instance: A #_PolkitSubject.
 *
 * Gets element 0 of the #EggDBusStructure wrapped by #_PolkitSubject.
 *
 * Returns: The type of the subject.
 */
const gchar *
_polkit_subject_get_subject_kind (_PolkitSubject *instance)
{
  const gchar *value;

  g_return_val_if_fail (_POLKIT_IS_SUBJECT (instance), NULL);

  egg_dbus_structure_get_element (EGG_DBUS_STRUCTURE (instance),
                0, &value,
                -1);

  return value;
}

/**
 * _polkit_subject_get_subject_details:
 * @instance: A #_PolkitSubject.
 *
 * Gets element 1 of the #EggDBusStructure wrapped by #_PolkitSubject.
 *
 * Returns: Details about the subject. Depending of the value of @subject_kind, a set of well-defined key/value pairs are guaranteed to be available.
 */
EggDBusHashMap *
_polkit_subject_get_subject_details (_PolkitSubject *instance)
{
  EggDBusHashMap *value;

  g_return_val_if_fail (_POLKIT_IS_SUBJECT (instance), NULL);

  egg_dbus_structure_get_element (EGG_DBUS_STRUCTURE (instance),
                1, &value,
                -1);

  return value;
}


/**
 * _polkit_subject_set_subject_kind:
 * @instance: A #_PolkitSubject.
 * @value: The type of the subject.
 *
 * Sets element 0 of the #EggDBusStructure wrapped by #_PolkitSubject.
 */
void
_polkit_subject_set_subject_kind (_PolkitSubject *instance, const gchar *value)
{
  g_return_if_fail (_POLKIT_IS_SUBJECT (instance));

  egg_dbus_structure_set_element (EGG_DBUS_STRUCTURE (instance),
                0, value,
                -1);
}

/**
 * _polkit_subject_set_subject_details:
 * @instance: A #_PolkitSubject.
 * @value: Details about the subject. Depending of the value of @subject_kind, a set of well-defined key/value pairs are guaranteed to be available.
 *
 * Sets element 1 of the #EggDBusStructure wrapped by #_PolkitSubject.
 */
void
_polkit_subject_set_subject_details (_PolkitSubject *instance, EggDBusHashMap *value)
{
  g_return_if_fail (_POLKIT_IS_SUBJECT (instance));

  egg_dbus_structure_set_element (EGG_DBUS_STRUCTURE (instance),
                1, value,
                -1);
}


/**
 * _polkit_subject_new:
 * @subject_kind: The type of the subject.
 * @subject_details: Details about the subject. Depending of the value of @subject_kind, a set of well-defined key/value pairs are guaranteed to be available.
 *
 * Constructs a new #_PolkitSubject.
 *
 * Returns: A #_PolkitSubject.
 */
_PolkitSubject *
_polkit_subject_new (const gchar *subject_kind, EggDBusHashMap *subject_details)
{
  GValue *values;
  _PolkitSubject *structure;

  values = g_new0 (GValue, 2);

  g_value_init (&(values[0]), G_TYPE_STRING);
  g_value_set_string (&(values[0]), subject_kind);

  g_value_init (&(values[1]), EGG_DBUS_TYPE_HASH_MAP);
  g_value_set_object (&(values[1]), subject_details);

  structure = _POLKIT_SUBJECT (g_object_new (_POLKIT_TYPE_SUBJECT, "signature", "(sa{sv})", "elements", values, NULL));

  return structure;
}

